﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FlacPlugIn.DynamicEconomy {
  internal class ConsumerCommodity: Commodity {
    public ConsumerCommodity(uint baseID, uint goodID, float localeFactor, float basePrice)
      : base(baseID, goodID) {
      InStock = 0;
      ConsumptionRate = 7;
      LocaleFactor = localeFactor;
      BasePrice = basePrice;
    }

    private float BasePrice { get; set; }

    protected override bool SellCommodity { get { return false; } }

    public int ConsumptionRate { get; set; }

    public float LocaleFactor { get; private set; }

    public override float StorePrice {
      get {
        float storePrice = LocaleFactor * BasePrice * PriceFactor + (SupplierPrice  - BasePrice);
        return storePrice < 1? 1: storePrice;
      }
    }

    private float SupplierPrice { get { return BaseManager.Instance.Producers.GetSupplierPrice(GoodID); } }

    protected override void Update() {
      int oldStock = InStock;
      InStock -= ConsumptionRate;
      if(oldStock == InStock) return;
    }
  }
}
