﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EagleWare.Libraries.GeneralNonsense;

namespace FlacPlugIn.DynamicEconomy {
  internal class Consumers: Bases {
    private class Consumer: Base {
      public Consumer(uint baseID) : base(baseID) { }

      public void AddConsumerCommodity(uint goodID, float localeFactor, float basePrice) {
        if(GetCommodity(goodID) != null) return;
        AddCommodity(new ConsumerCommodity(BaseID, goodID, localeFactor, basePrice));
      }

      public ConsumerCommodity GetConsumerCommodity(uint goodID) {
        return GetCommodity(goodID) as ConsumerCommodity;
      }
    }

    public Consumers() { }

    private void AddConsumer(uint baseID) {
      AddBase(new Consumer(baseID));
    }

    private Consumer GetConsumer(uint baseID) {
      return GetBase(baseID) as Consumer;
    }

    public void AddConsumerCommodity(uint baseID, uint goodID, float localeFactor, float basePrice) {
      AddConsumer(baseID);
      GetConsumer(baseID).AddConsumerCommodity(goodID, localeFactor, basePrice);
    }
  }
}
