﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using EagleWare.Libraries.FLServerCommunications.Notifications;

namespace FlacPlugIn.DynamicEconomy {
  public class NotificationHandler: Listener {
    public NotificationHandler() {
      InitializeUtilities();

      new MarketCommoditiesParser().CreateDynamicCommodityMarket();

      BaseManager.Instance.InitializeServer();
    }

    public override void UnInitialized(UnInitialized notification) {
      _log.Info("UnInitialized notification received.");

      BaseManager.Instance.InitializeServer();
    }

    private void InitializeUtilities() {
      Utilities.Instance.Log = _log;
      Utilities.Instance.TimerFactory = _timerFactory;
      Utilities.Instance.ThreadingFactory = _threadingFactory;
    }

    public override void Trade(Trade notification) {
      BaseManager.Instance.ProcessTrade(
        notification.BaseID, notification.GoodID, notification.Count, notification.IsPurchase
      );
    }
  }
}
