﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FlacPlugIn.DynamicEconomy {
  internal class ProducerCommodity: Commodity {
    public ProducerCommodity(
      uint baseID, uint goodID, float nominalPrice, float resellerRate
    ): base(baseID, goodID) {
      InStock = StockCapacity;
      ProductionRate = 7;
      NominalPrice = nominalPrice;
      ResellerRate = BaseManager.Instance.Producers.SetGlobalResellerRate(goodID, resellerRate);
    }

    protected override bool SellCommodity { get { return ProductionRate < InStock; } }

    public int ProductionRate { get; set; }

    public float ResellerRate { get; set; }

    public float NominalPrice { get; private set; }

    public override float StorePrice { get { return NominalPrice * PriceFactor; } }

    public float ResellerPrice { get { return ResellerRate * StorePrice; } }

    protected override void Update() {
      int oldStock = InStock;
      InStock += ProductionRate;
      if(oldStock == InStock) return;
    }
  }
}
