﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EagleWare.Libraries.GeneralNonsense;

namespace FlacPlugIn.DynamicEconomy {
  internal class Resellers: Bases {
    private class Reseller: Base {
      public Reseller(uint baseID) : base(baseID) { }

      public void AddResellerCommodity(uint goodID, float localeFactor, float basePrice) {
        if(GetCommodity(goodID) != null) return;
        AddCommodity(new ResellerCommodity(BaseID, goodID, localeFactor, basePrice));
      }

      public ResellerCommodity GetResellerCommodity(uint goodID) {
        return GetCommodity(goodID) as ResellerCommodity;
      }
    }

    public Resellers() { }

    private void AddReseller(uint baseID) {
      AddBase(new Reseller(baseID));
    }

    private Reseller GetReseller(uint baseID) {
      return GetBase(baseID) as Reseller;
    }

    public void AddResellerCommodity(uint baseID, uint goodID, float localeFactor, float basePrice) {
      AddReseller(baseID);
      GetReseller(baseID).AddResellerCommodity(goodID, localeFactor, basePrice);
    }
  }
}
