﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FlacCommands;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;

namespace FlacPlugIn.BattleCry {
  class BoldSystemChat: PlayerCommand {
    private Logger _log = Settings.Instance.Logger;

    public BoldSystemChat() {
      Syntax += " [message]";
      Description = "Sends message as system chat in bold font.";
    }

    public override void Execute(Player user, string parameters) {
      GetSystem.Fire(user, delegate(SystemUpdate update) {
        foreach(Player player in Settings.Instance.ServerInformation.OnlinePlayers) {
          SendSystemChat(update, player, user, parameters);
        }
      });
    }

    private void SendSystemChat(SystemUpdate targetSystem, Player to, Player from, string message) {
      GetSystem.Fire(to, delegate(SystemUpdate update) {
        if(targetSystem.System != update.System) return;
        _log.Info("Sending message to {0}", to.Name);
        PrivateChat.Fire(to, 0xE6C68401, string.Format("{0}: {1}", from.Name, message));
      });
    }
  }
}
