﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using EagleWare.Libraries.FlacCommands;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;

namespace FlacPlugIn.BullDogg
{
    internal class FactionBank : AdminCommand
    {
        public FactionBank()
        {
            Syntax += "[deposit/withdraw/balance] [account] [password] [ammount]";
            Description = "Allows transfer of credits to and from a faction bank account.";
        }

        public override void Execute(Player user, string parameters)
        {
            string option = parameters.ToLower().Trim();
            string[] StrOption = new string[2];
            char[] splitter = { ' ' };
            StrOption = option.Split(splitter);

            if (StrOption[0] != "balance" && StrOption[0] != "deposit" && StrOption[0] != "withdraw")
            {
                PrivateChat.Fire(
                  user, string.Format("Unrecognized option {0}, use balance/deposit/withdraw instead.", StrOption[0])
                );
                return;
            }
            else
            {
                if (StrOption[0] == "balance")
                {
                    XmlDocument xmlDoc = new XmlDocument();
                    xmlDoc.Load(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\factionbankaccounts\accounts.xml");
                    XmlNodeList nodeList = xmlDoc.SelectNodes("//FactionBankAccounts/account");
                    foreach (XmlNode node in nodeList)
                    {
                        if (node.Attributes["name"].Value == StrOption[1])
                        {
                            string balance = node.Attributes["balance"].Value;

                            PrivateChat.Fire(user,
                     string.Format("Account Balance is {0]", balance)
                );
                            
                        }
                    }
                }
                else if (StrOption[0] == "deposit")
                {
                    UniverseCustomChat.Fire(0xFFFFFF20, string.Format(""));
                }
                else if (StrOption[0] == "withdraw")
                {
                    UniverseCustomChat.Fire(0xFFFFFF01, string.Format(""));
                }
                else
                {
                    PrivateChat.Fire(
                  user, string.Format("Unrecognized option {0}, use big/medium/small instead.", StrOption[0])
                );
                }
            }           

            
        }
    }
}
