﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using EagleWare.Libraries.FlacCommands;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;

namespace FlacPlugIn.BullDogg
{
    

    internal class Shout : AdminCommand
    {
        private Dictionary<string, Action<string>> _messageAction;
        private Regex _shoutRegularExpression;

        public Shout()
        {
            _messageAction = new Dictionary<string, Action<string>>();
            _messageAction["small"] = SendSmallMessage;
            _messageAction["medium"] = SendMediumMessage;
            _messageAction["large"] = SendLargeMessage;
            string options = string.Join("|", new List<string>(_messageAction.Keys).ToArray());
            string pattern = string.Format(@"^\s*(?<Size>((?i){0}(?-i)))\s+(?<Message>.+)$", options);
            _shoutRegularExpression = new Regex(pattern, RegexOptions.Singleline | RegexOptions.CultureInvariant);
            Syntax += string.Format(" [{0}] [message]", options);
            Description = "Shouts to universe.";
        }

        private void SendSmallMessage(string message)
        {
            UniverseCustomChat.Fire(0xFFFFFF01, message);
        }

        private void SendMediumMessage(string message)
        {
            UniverseCustomChat.Fire(0xFFFFFF30, message);
        }

        private void SendLargeMessage(string message)
        {
            UniverseCustomChat.Fire(0xFFFFFF20, message);
        }       

             
        
        public override void Execute(Player user, string parameters) {
    if(!_shoutRegularExpression.IsMatch(parameters)) {
      // Invalid input, show error message to user
      return;
    }
    Match match = _shoutRegularExpression.Match(parameters);
    _messageAction[match.Groups["Size"].Value.ToLower()](match.Groups["Message"].Value);
  }
      
}
      
        }
    


