﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;

namespace FlacPlugIn.TrackerPlug {
  public class NotificationHandler: Listener {
    public NotificationHandler() {

      new Tracker().Register();

    }

    private string GetTradeItem(uint hash)
    {
        return HashDictionary.Instance.GetTranslation(hash) ?? string.Format("some item (hash = {0})", hash);
    }

    private string GetBaseName(uint hash)
    {
        return HashDictionary.Instance.GetTranslation(hash) ?? string.Format("some base (hash = {0})", hash);
    }

    public override void Trade(Trade notification)
    {       

        string logpath = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\trackplayer.log";

        XmlDocument document = new XmlDocument();
        document.Load(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\trackplayer.xml");
        XmlNode node = document.DocumentElement.SelectSingleNode("//PlayerToTrack");

        if (notification.PlayerName == node.InnerText)
        {
            string tracklog = String.Format(DateTime.Now + " TRACKER -- {0}, bought = {1}, item = {2}, ammount = {3}, price = {4}, base = {5}",
        notification.PlayerName,
        notification.IsPurchase,
        GetSystemName(notification.GoodID),
        notification.Count,
        notification.Price,
        GetBaseName(notification.BaseID));

            TextWriter tw = new StreamWriter(logpath, true);
            tw.WriteLine(tracklog);
            tw.Close();

        }
        else { }
    }

    public override void ShipDestroyed(ShipDestroyed notification) {

        string logpath = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\trackplayer.log";

        XmlDocument document = new XmlDocument();
        document.Load(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\trackplayer.xml");
        XmlNode node = document.DocumentElement.SelectSingleNode("//PlayerToTrack");

        if (notification.Target == node.InnerText)
        {
            string tracklog = String.Format(DateTime.Now + " TRACKER -- {0} was killed by {1}, cause={2}",
        notification.Target,
        notification.Killer,
        notification.DestroyCause);

            TextWriter tw = new StreamWriter(logpath, true);
            tw.WriteLine(tracklog);
            tw.Close();

        }
        else if (notification.Killer == node.InnerText)
        {
            string tracklog = String.Format(DateTime.Now + " TRACKER -- {1} killed {0}, cause={2}",
                    notification.Target,
                    notification.Killer,
                    notification.DestroyCause);

            TextWriter tw = new StreamWriter(logpath, true);
            tw.WriteLine(tracklog);
            tw.Close();
        }
        else { }    
    }

    private string GetSystemName(uint hash) {
      return HashDictionary.Instance.GetTranslation(hash) ?? string.Format("some system (hash = {0})", hash);
    }  

    public override void EnteredSystem(EnteredSystem notification)
    {

        // _log.Info("TRACKER -- {0} Jumped to {1}", notification.PlayerName, GetSystemName(notification.System));
        
        string logpath = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\trackplayer.log";
        string jumplog = String.Format(DateTime.Now + " TRACKER -- {0} Jumped to {1}", notification.PlayerName, GetSystemName(notification.System));

        XmlDocument document = new XmlDocument();
        document.Load(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\trackplayer.xml");
        XmlNode node = document.DocumentElement.SelectSingleNode("//PlayerToTrack");

        if (notification.PlayerName == node.InnerText)
        {
        
        if (File.Exists(logpath))
        {
            TextWriter tw = new StreamWriter(logpath, true);
            tw.WriteLine(jumplog);
            tw.Close();
        }
        else
        {
            FileInfo LogFile = new FileInfo(logpath);
            //FileInfo LogFile = new FileInfo(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\trackplayer.log");
            LogFile.Create();

            TextWriter tw = new StreamWriter(logpath, true);
            tw.WriteLine(jumplog);
            tw.Close();
        }

        }
        else
        {
        }
        

    }
      
  }
}

/*public override void EnteredSystem(EnteredSystem notification) {
    UniverseCustomChat.Fire(
      0x0000FF01, // bright red, bold
      string.Format(
        "{0} just entered {1}.",
        notification.PlayerName,
        GetSystemName(notification.System)
      )
    );
  }*/

/*public override void CharacterLoad(CharacterLoad notification) {
    _log.Info(
      "CharacterLoad notification received in FlacPlugIn.TrackerPlug: IPEndPoint={0}, SaveGame={1}",
      notification.Address,
      notification.SaveGameFullPath       

    );
    PrivateChat.Fire(
      new Player(notification.SaveGameFullPath),
      "CharacterLoad received by FlacPlugIn.TrackerPlug"        
    );
  }*/