﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Xml;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;
using EagleWare.Libraries.FLServerCommunications.Utilities;
using EagleWare.Libraries.FreelancerTrivia;

namespace FlacPlugIn.DockMessage {
  internal class HashDictionary {
    public static HashDictionary Instance { get { return Singleton<HashDictionary>.Instance; } }

    private Dictionary<uint, string> _names;
    internal Dictionary<uint, string> _dockmessages;

    private HashDictionary()
    {
        //Settings.Instance.ServerInformation = this._serverInformation;

        string[] lines = File.ReadAllLines(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\HashDb.ini");
        _names = new Dictionary<uint, string>();
        foreach (String line in lines)
        {
            String[] split = line.Split('=');
            string hash = split[0];
            string value = split[1];
            //"_names [" + split[0] + "] = " + split[1];

            _names[UInt32.Parse(hash)] = value;

        }

       // string configFile = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\DockMessages.xml";
        _dockmessages = new Dictionary<uint, string>();

        string[] dockmessages = File.ReadAllLines(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\DockMessages.ini");
        foreach (String dockmessage in dockmessages)
        {
            String[] split = dockmessage.Split('=');
            string hash = split[0];
            string message = split[1];
            uint hashCode = Hash.Instance.Calculate(hash);
            //"_names [" + split[0] + "] = " + split[1];

            _dockmessages[hashCode] = message;
           
        }
    }

    public string GetTranslation(uint hash)
    {
        if (!_dockmessages.ContainsKey(hash)) return null;
        return _dockmessages[hash];
    }
  }
}
