﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Xml;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;
using EagleWare.Libraries.FLServerCommunications.Utilities;
using EagleWare.Libraries.FreelancerTrivia;

namespace FlacPlugIn.DockMessage {
  public class NotificationHandler: Listener {
    public NotificationHandler() {                
      Settings.Instance.ServerInformation = this._serverInformation;
      Settings.Instance.Logger = this._log;
      new ListDockMessages().Register(); 
    } 
    

    public override void EnteredBase(EnteredBase notification)
    {
        string dockMessage = HashDictionary.Instance.GetTranslation(notification.Base);
        if (dockMessage == null)
        {
            return;
        }

        if (HashDictionary.Instance._dockmessages.ContainsKey(notification.Base)) // <-- Use this
        {
            PrivateChat.Fire(_serverInformation.OnlinePlayers.Single(p => p.Name == notification.PlayerName), dockMessage);
        }
        else
        {
            PrivateChat.Fire(_serverInformation.OnlinePlayers.Single(p => p.Name == notification.PlayerName), "ERROR");
        }
        
        //PrivateChat.Fire(_serverInformation.OnlinePlayers.Single(p => p.Name == notification.PlayerName), String.Format("docked at:{0}", GetBaseName(notification.Base)));             
    }
         
  }
}

