﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;
using System.Threading;
using Meebey.SmartIrc4net;


namespace FlacPlugIn.irctofl {
  public class NotificationHandler: Listener {
    public NotificationHandler() {
      Settings.Instance.ServerInformation = this._serverInformation;
      Settings.Instance.Logger = this._log;

     
    }
      public static IrcClient irc = new IrcClient();

        public static void OnChannelMessage(object sender, IrcEventArgs e)
        {
            UniverseCustomChat.Fire(0xFF000001, string.Format(e.Data.Nick + ": " + e.Data.Message));
        }

        public static void Main(string[] args)
        {
            Thread.CurrentThread.Name = "Main";

            // UTF-8 test
            irc.Encoding = System.Text.Encoding.UTF8;

            // wait time between messages, we can set this lower on own irc servers
            irc.SendDelay = 200;

            // we use channel sync, means we can use irc.GetChannel() and so on
            irc.ActiveChannelSyncing = true;

            // here we connect the events of the API to our written methods
            // most have own event handler types, because they ship different data
            irc.OnChannelMessage += new IrcEventHandler(OnChannelMessage);

            string[] serverlist;
            // the server we want to connect to, could be also a simple string
            serverlist = new string[] { "irc.quakenet.org" };
            int port = 6667;
            string channel = "#lancersreactor";
            try
            {
                // here we try to connect to the server and exceptions get handled
                irc.Connect(serverlist, port);
            }
            catch (ConnectionException e)
            {
                // something went wrong, the reason will be shown
                UniverseCustomChat.Fire(0xFF000001, string.Format("couldn't connect! Reason: " + e.Message));

            }

            try
            {
                // here we logon and register our nickname and so on 
                //System.Console.WriteLine("Logging into IRC Server");
                irc.Login("BETABot", "FL Test Bot");
                //System.Console.WriteLine("Logging in Done!");
                // join the channel
                //System.Console.WriteLine("Joining Assigned Channel");
                irc.RfcJoin(channel);

                irc.Listen();

                // when Listen() returns our IRC session is over, to be sure we call
                // disconnect manually
                irc.Disconnect();
            }
            catch (ConnectionException)
            {
                // this exception is handled because Disconnect() can throw a not
                // connected exception

            }
            catch (Exception e)
            {
                // this should not happen by just in case we handle it nicely
                UniverseCustomChat.Fire(0xFF000001, string.Format("Error occurred! Message: " + e.Message));
                UniverseCustomChat.Fire(0xFF000001, string.Format("Exception: " + e.StackTrace));

            }
        }

   
    }
   
  }

