﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;
using System.Threading;
using System.ComponentModel;
using System.Data;
using System.Net;
using System.Net.Sockets;


namespace FlacPlugIn.irctofl {

  public class NotificationHandler: Listener {

      public AsyncCallback pfnWorkerCallBack;
      public Socket m_socListener;
      public Socket m_socWorker;
      public IAsyncResult asyn;

      public NotificationHandler()
      {        
          Settings.Instance.ServerInformation = this._serverInformation;
          Settings.Instance.Logger = this._log;        
      }

      public void Main()
      {
          //create the listening socket...
          m_socListener = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
          IPEndPoint ipLocal = new IPEndPoint(IPAddress.Any, 8221);
          //bind to local IP Address...
          m_socListener.Bind(ipLocal);
          //start listening...
          m_socListener.Listen(4);
          // create the call back for any client connections...
          m_socListener.BeginAccept(new AsyncCallback(OnClientConnect), null);
      }           
      

      public void OnClientConnect(IAsyncResult asyn)
      {         
              m_socWorker = m_socListener.EndAccept(asyn);

              WaitForData(m_socWorker);         
         

      }

          public  void OnDataReceived(IAsyncResult asyn)
		{

            CSocketPacket theSockId = (CSocketPacket)asyn.AsyncState;
            //end receive...
            int iRx = 0;
            iRx = theSockId.thisSocket.EndReceive(asyn);
            char[] chars = new char[iRx + 1];
            System.Text.Decoder d = System.Text.Encoding.UTF8.GetDecoder();
            int charLen = d.GetChars(theSockId.dataBuffer, 0, iRx, chars, 0);
            System.String szData = new System.String(chars);
            string s = "";
            s = new string(chars);
                

                UniverseCustomChat.Fire(
          0xFF000001,
          string.Format("IRC: {0}", s)
        );

				
				WaitForData(m_socWorker );
						
		}

          public void WaitForData(System.Net.Sockets.Socket soc)
          {              
                  if (pfnWorkerCallBack == null)
                  {
                      pfnWorkerCallBack = new AsyncCallback(OnDataReceived);
                  }
                  CSocketPacket theSocPkt = new CSocketPacket();
                  theSocPkt.thisSocket = soc;
                  // now start to listen for any data...
                  soc.BeginReceive(theSocPkt.dataBuffer, 0, theSocPkt.dataBuffer.Length, SocketFlags.None, pfnWorkerCallBack, theSocPkt);
             
          }
      }

        public class CSocketPacket
		{
			public System.Net.Sockets.Socket thisSocket;
			public byte[] dataBuffer = new byte[1];
		}

      
     
    }
    

        

   
    
   
  

