﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using EagleWare.Libraries.FlacCommands;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;
using EagleWare.Libraries.GeneralNonsense;


namespace FlacPlugIn.JoinMessage {
  internal class SetJoinMessage: PlayerCommand {
    public SetJoinMessage() {
      Syntax += " [message]";
      Description = "Allows the player to set their message to be shown when they join the server.";
    }

    public override void Execute(Player user, string parameters) {
        string twpath = user.SaveGameFullPath;
        string twpath2;
        string twfile3;
        string twpath4;
        string linetowrite = user.Name + ": " + parameters;
        System.IO.FileInfo sourceFileInfo = new System.IO.FileInfo(twpath);
        twpath2 = sourceFileInfo.DirectoryName;
        twpath4 = sourceFileInfo.Name;
        twfile3 = twpath2 + "/joinmsg" + twpath4 + ".txt";

        if (File.Exists(twfile3))
        {
            TextWriter tw = new StreamWriter(twfile3);
            tw.WriteLine(linetowrite);
            tw.Close();
            PrivateChat.Fire(user, "Join Server Message Updated!");
        }
        else
        {
            PrivateChat.Fire(user, "Setting up Join Server Message...");
            StreamWriter CreateFile = File.CreateText(twfile3);
            CreateFile.Close();
            TextWriter tw = new StreamWriter(twfile3);
            tw.WriteLine(linetowrite);            
            tw.Close();
            PrivateChat.Fire(user, "Join Server Message Created!");
        }   
    }
  }
}
