﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;

namespace FlacPlugIn.KillLogPlug {
  public class NotificationHandler: Listener {

      public string logpath = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\killlog.log";
      public string destroycause;

    public NotificationHandler() 
    {
        CreateLog();
    }       

    public override void ShipDestroyed(ShipDestroyed notification) {

        if (notification.DestroyCause.Equals("UnLoad"))
        {
            destroycause = "Player used F1 menu or docked.";
        }
        else
        {
            destroycause = Convert.ToString(notification.DestroyCause);
        }

        string killentry = String.Format(DateTime.Now + " - {0} was killed by {1}, cause={2}",
        notification.Target,
        notification.Killer,
        destroycause);

            if (File.Exists(logpath))
            {
                WriteToLog(killentry);
            }
            else
            {
                CreateLog();
                WriteToLog(killentry);
            }     
    }


    public void WriteToLog(string entry)
    {
        TextWriter tw = new StreamWriter(logpath, true);
        tw.WriteLine(entry);
        tw.Close();
    }

    public void CreateLog()
    {
        FileInfo MyFile = new FileInfo(logpath);
        MyFile.Create();
        MyFile.Refresh();
    }

  }
}

