﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;
using EagleWare.Libraries.FLServerCommunications.Utilities;


namespace FlacPlugIn.TradeLogPlug
{    

    public class NotificationHandler : Listener
    {        
        public string ispurchase;
        public string logpath = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\tradelog.log";

        public NotificationHandler()
        {
            CreateLog();
        }        

        private string GetHash(uint hash)
        {
            return HashDictionary.Instance.GetTranslation(hash) ?? string.Format("some object (hash = {0})", hash);
        }

        public override void Trade(Trade notification)
        {

           

            if (notification.IsPurchase.Equals(true))
            {
                ispurchase = "Purcahsed";
            }
            else
            {
                ispurchase = "Sold";
            }

            string tradeentry = String.Format(DateTime.Now + " - {0}, Purchased/Sold = {1}, item = {2}, ammount = {3}, price per unit = {4}, base = {5}",
           notification.PlayerName,
           ispurchase,
           GetHash(notification.GoodID),
           notification.Count,
           notification.Price,
           GetHash(notification.BaseID));

            if (File.Exists(logpath))
            {
                WriteToLog(tradeentry);
            }
            else
            {
                CreateLog();
                WriteToLog(tradeentry);
            }                       
        }

        public void WriteToLog(string entry)
        {
            TextWriter tw = new StreamWriter(logpath, true);
            tw.WriteLine(entry);
            tw.Close();
        }

        public void CreateLog()
        {
            FileInfo MyFile = new FileInfo(logpath);
            MyFile.Create();
            MyFile.Refresh();
        }
    }
}

