﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;
using EagleWare.Libraries.FlacCommands;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications.Notifications;


namespace FlacPlugIn.PayPerBanner {

    internal class Settings 
    { 
        public static Settings Instance 
        { 
            get 
            { 
                return Singleton<Settings>.Instance; 
            } 
        } 

        private Settings() 
        { 
        } 
        
        public bool LastSent 
        { 
            get; 
            set;            
        } 
    }

  internal class PlayerU: PlayerCommand {

    public PlayerU() {
      Syntax += " [message]";
      Description = "Allows players to pay to send out a universal message.";
    }

   private string logpath = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\universepaylog.log";
   private int creditloss = 0;
   private int currentcash;

    private void GetSettings()
    {
        XmlDocument document = new XmlDocument();
        document.Load(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\payperbannerconfig.xml");
        XmlNode node = document.DocumentElement.SelectSingleNode("//Price");
        creditloss = Convert.ToInt32(node.InnerText.ToString());        
    }    

    public override void Execute(Player user, string parameters) {
        GetSettings();

        GetCash.Fire(
        user,
        delegate(CashUpdate notification)
        {
            currentcash = notification.Amount;
            //PrivateChat.Fire(user, currentcash + " " + creditloss);
        

        int requiredcash = creditloss - currentcash;
                    
        
        if (!File.Exists(logpath))
        {            
           CreateLog();  
        }      
  
        if (parameters == "")
        {
            PrivateChat.Fire(user,
                      "You did not enter a message to send."
                    );
            return;            
        }
        else if (creditloss >= currentcash)
        {
            PrivateChat.Fire(user,
                     string.Format("You do not have the required credits to perform this action. You require another {0} to send a banner.")
                   );
            return;
        }
        

        EagleWare.Libraries.FLServerCommunications.Events.AddCash.Fire(user, creditloss);            

            UniverseCustomChat.Fire(0xFFFFFF30, user.Name + ": " + parameters);

            string entry = string.Format("Player: {0}, Credit Charge: {1}, Message: {2}.", user.Name, creditloss, parameters);
            WriteToLog(entry);

            PrivateChat.Fire(user, string.Format("Message sent to universe. You have had {0} credits deducted from your account to submit the message '{1}'.", creditloss, parameters));
        }
      );   
    }
    private void WriteToLog(string entry)
    {
        TextWriter tw = new StreamWriter(logpath, true);
        tw.WriteLine(entry);
        tw.Close();
    }

    private void CreateLog()
    {
        FileInfo MyFile = new FileInfo(logpath);
        MyFile.Create();
        MyFile.Refresh();
    }    

  }  

}
