﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;
using SG = EagleWare.Libraries.FreelancerTrivia.SaveGames;

namespace FlacPlugIn.AdminJoin 
{   

  public class NotificationHandler: Listener 
  {
      public XmlNode admintag;
      public XmlNode policetag;
      private SG.Factory _factory;

      public NotificationHandler()
      {
          _factory = new SG.Factory();
      }

      public void GetConfig()
      {
          XmlDocument document = new XmlDocument();
          document.Load(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\FLAntiCheat\AdminJoinConfig.xml");
          XmlNode admintag = document.DocumentElement.SelectSingleNode("/AdminJoinConfig/AdminTag");
          XmlNode policetag = document.DocumentElement.SelectSingleNode("/AdminJoinConfig/PoliceTag");
      }
          
    public override void CharacterLoad(CharacterLoad notification)
    {          
        GetConfig();
          SG.SaveGame saveGame = _factory.GetSaveGame(notification.SaveGameFullPath);       

        string AdminTag = admintag.InnerText;
        string PoliceTag = policetag.InnerText;

        if (saveGame.Name.StartsWith(AdminTag))
        {
            UniverseCustomChat.Fire(0xFFFFF00, string.Format("An Admin Called '{0}' has Joined the Server. ", saveGame.Name));           
        }
        else if (saveGame.Name.StartsWith(PoliceTag))
        {
            UniverseCustomChat.Fire(0xFFFFF00, string.Format("A Member of the Server Police Called '{0}' has Joined the Server. ", saveGame.Name));           
        }
    }

  }
}

