﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EagleWare.Libraries.FlacCommands;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;

namespace FlacPlugIn.ServerUptimePlug

{
    internal class ServerUptime : PlayerCommand
    {
        public ServerUptime()
        {
            Description = "Broadcasts the current Server Uptime to the player.";
        }   

        public override void Execute(Player user, string parameters)
        {
            PrivateChat.Fire(
            user,
            string.Format("Getting Server Uptime...")
          );

            PerformanceCounter pc = new PerformanceCounter("System", "System Up Time");            
            pc.NextValue();

            TimeSpan ts = TimeSpan.FromSeconds(pc.NextValue());                      

            PrivateChat.Fire(
            user,
            string.Format("The current server uptime is {0} Days {1} Hours and {2} Minutes.", ts.Days, ts.Hours, ts.Seconds)

          );
            PrivateChat.Fire(
            user,
            string.Format("Plugin by BullDogg")

          );

        }
    }
}