﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;
using SG = EagleWare.Libraries.FreelancerTrivia.SaveGames;

namespace FlacPlugIn.WelcomePlayer
{
    public class NotificationHandler : Listener
    {
       private SG.Factory _factory;

        public NotificationHandler()
        {
            _factory = new SG.Factory();
        }

        public override void CharacterLoad(CharacterLoad notification)
        {
            Player player = _serverInformation.OnlinePlayers.Single(p => p.SaveGameFullPath == notification.SaveGameFullPath);
            SG.SaveGame saveGame = _factory.GetSaveGame(notification.SaveGameFullPath);
            PrivateChat.Fire(player, String.Format("Welcome {0}", saveGame.Name));
            PrivateChat.Fire(player, String.Format("Your rank is: {0}", saveGame.Rank));
            PrivateChat.Fire(player, String.Format("You have {0} credits", saveGame.Credits));
            PrivateChat.Fire(player, String.Format("Your reputation group is {0}", saveGame.ReputationGroup));
        }
    }
}

