﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EagleWare.Libraries.GeneralNonsense;
using EagleWare.Libraries.FLServerCommunications;
using EagleWare.Libraries.FLServerCommunications.Events;
using EagleWare.Libraries.FLServerCommunications.Notifications;

namespace FlacPlugIn.AdminJoinPlug {
  public class NotificationHandler: Listener {
    public NotificationHandler() {
      // register new commands  
      
     
      }

    public override void CharacterLoad(CharacterLoad notification)
    {


        UniverseCustomChat.Fire(
        0xFF000001, // blue, bold
        string.Format("The current date and time (UTC) is: {0}", DateTime.UtcNow.ToString("HH:mm yyyy-MM-dd"))
      );
    }

    public bool IsMatch(string pattern, string input, bool caseInsensitive)
    {
        int offsetInput = 0;
        bool isAsterix = false;
        int i;

        while (true)
        {
            for (i = 0; i < pattern.Length; )
            {

                switch (pattern[i])
                {
                    case '?':
                        isAsterix = false;
                        offsetInput++;
                        break;
                    case '*':
                        isAsterix = true;
                        while (i < pattern.Length &&
                                    pattern[i] == '*')
                        {
                            i++;
                        }

                        if (i >= pattern.Length)
                            return true;
                        continue;
                    default:
                        if (offsetInput >= input.Length)
                            return false;

                        if ((caseInsensitive ?
                               char.ToLower(input[offsetInput]) :
                               input[offsetInput])
                            !=
                            (caseInsensitive ?
                               char.ToLower(pattern[i]) :
                               pattern[i]))
                        {
                            if (!isAsterix)
                                return false;
                            offsetInput++;
                            continue;
                        }
                        offsetInput++;
                        break;
                } // end switch
                i++;
            } // end for

            // have we finished parsing our input?
            if (i > input.Length)
                return false;

            // do we have any lingering asterixes we need to skip?
            while (i < pattern.Length && pattern[i] == '*')
                ++i;

            // final evaluation. The index should be pointing at the
            // end of the string.
            return (offsetInput == input.Length);
        }

    }


    }

  }

